import { EditorView, basicSetup } from 'codemirror';

let editor: EditorView = null;

export type EditorOptions = {
  extensions?: any[];
};
/**
 * 创建单例
 * @param el
 * @returns
 */
const createEditorInstance = (el?: HTMLDivElement, opts?: EditorOptions) => {
  if (editor && el) {
    el.appendChild(editor.dom);
    return editor;
  } else if (editor) {
    return editor;
  }
  const extensions = opts?.extensions || [];
  editor = new EditorView({
    extensions: [basicSetup, ...extensions],
    parent: el || document.body,
  });
  editor.dom.style.height = '100%';
  return editor;
};

/**
 * 每次都创建新的实例
 * @param el
 * @returns
 */
export const createEditor = (el: HTMLDivElement, opts?: EditorOptions) => {
  const extensions = opts?.extensions || [];
  const editor = new EditorView({
    extensions: [basicSetup, ...extensions],
    parent: el || document.body,
  });
  editor.dom.style.height = '100%';
  return editor;
};
export const getEditor = () => editor;

export { editor, createEditorInstance };
